# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports



class IOPopupWidget(Gtk.Popover):
    """docstring for IOPopupWidget."""

    def __init__(self):
        super(IOPopupWidget, self).__init__()

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()



    def _setup_styling(self):
        self.set_position(Gtk.PositionType.BOTTOM)
        self.set_size_request(320, 280)

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        event_system.subscribe("show_io_popup", self.show_io_popup)
        event_system.subscribe("append_to_io_list", self.append_io_widget)

    def _load_widgets(self):
        vbox = Gtk.Box()
        vbox.set_orientation(Gtk.Orientation.VERTICAL)

        vbox.show()
        self.add(vbox)

    def show_io_popup(self, widget = None, eve = None):
        self.popup()

    def append_io_widget(self, io_widget):
        self.get_children()[0].add(io_widget)
        io_widget.show_all()
