# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports



class TabHeaderTemplate(Gtk.Box):
    """ docstring for TabHeaderTemplate """

    ccount = 0
    def __new__(cls, *args, **kwargs):
        obj        = super(TabHeaderTemplate, cls).__new__(cls)
        cls.ccount += 1
        return obj


    def __init__(self, container, close_tab, label = None):
        super(TabHeaderTemplate, self).__init__()

        self.INDEX        = self.ccount
        self.NAME         = f"tab_{self.INDEX}"
        self.LABEL        = self.NAME if not label else label
        self._container   = container
        self._close_tab   = close_tab # NOTE: Close method in tab_mixin

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()

        self.show_all()


    def _setup_styling(self):
        self.set_orientation(0)
        self.set_hexpand(False)

    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        ...

    def _load_widgets(self):
        eve_box = Gtk.EventBox()
        label   = Gtk.Label()
        close   = Gtk.Button()
        icon    = Gtk.Image(stock=Gtk.STOCK_CLOSE)

        # NOTE: Setup with settings and from file
        label.set_xalign(0.0)
        label.set_margin_left(10)
        label.set_margin_right(10)
        label.set_hexpand(True)
        label.set_label(self.LABEL)


        close.set_always_show_image(True)
        close.set_hexpand(False)
        close.set_image( Gtk.Image.new_from_icon_name("gtk-close", 4) )
        close.connect("released", self._close_tab, *(self._container,))

        eve_box.add(label)
        self.add(eve_box)
        self.add(close)

    def set_tab_label(self, label = "untitled"):
        self.get_children()[0].get_children()[0].set_label(label)

    def get_tab_label(self):
        return self.get_children()[0].get_children()[0].get_text()
